gtk.Builder
Prev | The gtk Class Reference | Next

## gtk.Builder

gtk.Builder — Build an interface from an XML UI definition.

## Synopsis

    class gtk.Builder(gobject.GObject):
        gtk.Builder()
        def add_from_file(filename)
        def add_from_string(buffer, len)
        def connect_signals(user_data=None)
        def get_object(name)
        def get_objects()
        def get_translation_domain()
        def get_type_from_name(type_name)
        def set_translation_domain(domain)

## Ancestry

    +-- gobject.GObject
      +-- gtk.Builder

## gtk.Builder Properties

"translation-domain" | Read/Write | The translation domain used when translating property values that have been marked as translatable in interface descriptions. If the translation domain is None, GtkBuilder uses gettext(), otherwise dgettext(). Default value: None

## Description

A `gtk.Builder` is an auxiliary object that reads textual descriptions of a user interface and instantiates the described objects. To pass a description to a `gtk.Builder`, call `add_from_file` or `add_from_string`. These functions can be called multiple times; the builder merges the content of all descriptions.

A `gtk.Builder` holds a reference to all objects that it has constructed and drops these references when it is finalized. This finalization can cause the destruction of non-widget objects or widgets which are not contained in a toplevel window. For toplevel windows constructed by a builder, it is the responsibility of the user to call `gtk.Widget.destroy` to get rid of them and all the widgets they contain.

The functions `get_object` and `get_objects` can be used to access the widgets in the interface by the names assigned to them inside the UI description. Toplevel windows returned by these functions will stay around until the user explicitly destroys them with gtk_widget_destroy(). Other widgets will either be part of a larger hierarchy constructed by the builder (in which case you should not have to worry about their lifecycle), or without a parent, in which case they have to be added to some container to make use of them.

The function `connect_signals` and variants thereof can be used to connect handlers to the named signals in the description.

### gtk.Builder UI definition

`gtk.Builder` parses textual descriptions of user interfaces which are specified in an XML format which can be roughly described by the DTD below. We refer to these descriptions as GtkBuilder UI definitions or just UI definitions if the context is clear. Do not confuse GtkBuilder UI Definitions with GtkUIManager UI Definitions, which are more limited in scope.

    <!ELEMENT interface object* >
    <!ELEMENT object    (property|signal|child|ANY)* >
    <!ELEMENT property  PCDATA >
    <!ELEMENT signal    EMPTY >
    <!ELEMENT child     (object|ANY*) >

    <!ATTLIST interface  domain         	    #IMPLIED >
    <!ATTLIST object     id             	    #REQUIRED
                         class          	    #IMPLIED
                         type-func      	    #IMPLIED
                         constructor    	    #IMPLIED >
    <!ATTLIST property   name           	    #REQUIRED
                         translatable   	    #IMPLIED
                         comments               #IMPLIED
                         context                #IMPLIED >
    <!ATTLIST signal     name           	    #REQUIRED
                         handler        	    #REQUIRED
                         after          	    #IMPLIED
                         swapped        	    #IMPLIED
                         object         	    #IMPLIED
                         last_modification_time #IMPLIED >
    <!ATTLIST child      type           	    #IMPLIED
                         internal-child 	    #IMPLIED >

The toplevel element is <interface>. It optionally takes a "domain" attribute, which will make the builder look for translated strings using dgettext() in the domain specified. This can also be done by calling `set_translation_domain` on the builder. Objects are described by <object> elements, which can contain <property> elements to set properties, <signal> elements which connect signals to handlers, and <child> elements, which describe child objects (most often widgets inside a container, but also e.g. actions in an action group, or columns in a tree model). A <child> element contains an <object> element which describes the child object.

Typically, the specific kind of object represented by an <object> element is specified by the "class" attribute. If the type has not been loaded yet, GTK+ tries to find the _get_type() from the class name by applying heuristics. This works in most cases, but if necessary, it is possible to specify the name of the _get_type() explictly with the "type-func" attribute. As a special case, GtkBuilder allows to use an object that has been constructed by a GtkUIManager in another part of the UI definition by specifying the id of the GtkUIManager in the "constructor" attribute and the name of the object in the "id" attribute.

Objects must be given a name with the "id" attribute, which allows the application to retrieve them from the builder with gtk_builder_get_object(). An id is also necessary to use the object as property value in other parts of the UI definition.

Setting properties of objects is pretty straightforward with the <property>element: the "name" attribute specifies the name of the property, and the content of the element specifies the value. If the "translatable" attribute is set to a true value, GTK+ uses gettext() (or dgettext() if the builder has a translation domain set) to find a translation for the value. This happens before the value is parsed, so it can be used for properties of any type, but it is probably most useful for string properties. It is also possible to specify a context to disambiguate short strings, and comments which may help the translators.

GtkBuilder can parse textual representations for the most common property types: characters, strings, integers, floating-point numbers, booleans (strings like "TRUE", "t", "yes", "y", "1" are interpreted as `True`, strings like "FALSE, "f", "no", "n", "0" are interpreted as `False`), enumerations (can be specified by their name, nick or integer value), flags (can be specified by their name, nick, integer value, optionally combined with "|", e.g. "gtk.VISIBLE|gtk.REALIZED") and colors (in a format understood by gdk_color_parse()). Objects can be referred to by their name. Pixbufs can be specified as a filename of an image file to load. In general, GtkBuilder allows forward references to objects — an object doesn't have to constructed before it can be referred to. The exception to this rule is that an object has to be constructed before it can be used as the value of a construct-only property.

Signal handlers are set up with the <signal> element. The "name" attribute specifies the name of the signal, and the "handler" attribute specifies the function to connect to the signal. By default, GTK+ tries to find the handler using g_module_symbol(), but this can be changed by passing a custom GtkBuilderConnectFunc to gtk_builder_connect_signals_full(). The remaining attributes, "after", "swapped" and "object", have the same meaning as the corresponding parameters of the g_signal_connect_object() or g_signal_connect_data() functions. A "last_modification_time" attribute is also allowed, but it does not have a meaning to the builder.

Sometimes it is necessary to refer to widgets which have implicitly been constructed by GTK+ as part of a composite widget, to set properties on them or to add further children (e.g. the vbox of a GtkDialog). This can be achieved by setting the "internal-child" propery of the <child> element to a true value. Note that GtkBuilder still requires an <object> element for the internal child, even if it has already been constructed.

A number of widgets have different places where a child can be added (e.g. tabs vs. page content in notebooks). This can be reflected in a UI definition by specifying the "type" attribute on a <child> The possible values for the "type" attribute are described in the sections describing the widget-specific portions of UI definitions.

### A gtk.Builder UI definition example

    <interface>
      <object class="GtkDialog" id="dialog1">
        <child internal-child="vbox">
          <object class="GtkVBox" id="vbox1">
            <property name="border-width">10</property>
            <child internal-child="action_area">
              <object class="GtkHButtonBox" id="hbuttonbox1">
                <property name="border-width">20</property>
                <child>
                  <object class="GtkButton" id="ok_button">
                    <property name="label">gtk-ok</property>
                    <property name="use-stock">TRUE</property>
                    <signal name="clicked" handler="ok_button_clicked"/>
                  </object>
                </child>
              </object>
            </child>
          </object>
        </child>
      </object>
    </interface>

Beyond this general structure, several object classes define their own XML DTD fragments for filling in the ANY placeholders in the DTD above. Note that a custom element in a <child> element gets parsed by the custom tag handler of the parent object, while a custom element in an <object> element gets parsed by the custom tag handler of the object.

## Constructor

        gtk.Builder()

Returns : | a new builder object.

Creates a new builder object.

## Methods

### gtk.Builder.add_from_file

        def add_from_file(filename)

`filename` : | The name of the file to parse.
Returns : | A positive value on success, 0 if an error occurred.

### Note

This method is available in PyGTK 2.12 and above.

The `add_from_file`() method parses a file containing a GtkBuilder UI definition and merges it with the current contents of builder.

### gtk.Builder.add_from_string

        def add_from_string(buffer, len)

`buffer` : | The string to parse.
`len` : | The length of buffer (may be -1 if buffer is nul-terminated).
Returns : | A positive value on success, 0 if an error occurred.

### Note

This method is available in PyGTK 2.12 and above.

The `add_from_string`() method parses a string containing a GtkBuilder UI definition and merges it with the current contents of builder.

### gtk.Builder.connect_signals

        def connect_signals(object, user_data)

`object` : | A mapping or an instance.
`user_data` : | User data for every signal handler.

### Note

This method is available in PyGTK 2.12 and above.

The `connect_signals`() method uses Python's introspective features to look at the keys (if object is a mapping) or attributes (if object is an instance) and tries to match them with the signal handler names given in the interface description. The callbacks referenced by each matched key or attribute are connected to their matching signals.

### gtk.Builder.get_object

        def get_object(name)

`name` : | Name of object to get.
Returns : | The object named name or None if it could not be found in the object tree.

### Note

This method is available in PyGTK 2.12 and above.

The `get_object`() method gets the object named name.

### gtk.Builder.get_objects

        def get_objects()

Returns : | A list containing all the objects constructed by the GtkBuilder instance

### Note

This method is available in PyGTK 2.12 and above.

The `get_objects`() method gets all objects that have been constructed by builder.

### gtk.Builder.get_translation_domain

        def get_translation_domain()

Returns : | The translation domain.

### Note

This method is available in PyGTK 2.12 and above.

The `get_translation_domain`() gets the translation domain of builder.

### gtk.Builder.get_type_from_name

        def get_type_from_name(type_name)

`type_name` : | The name to lookup.
Returns : | The GType found for type_name or G_TYPE_INVALID if no type was found

### Note

This method is available in PyGTK 2.12 and above.

The `get_type_from_name`() method looks up a type by name, using the virtual function that GtkBuilder has for that purpose.

### gtk.Builder.set_translation_domain

        def set_translation_domain(domain)

`domain` : | The translation domain or None.

### Note

This method is available in PyGTK 2.12 and above.

The `set_translation_domain`() method sets the translation domain of builder. See GtkBuilder:translation-domain property.

Prev | Up | Next
gtk.Button | Home | gtk.Buildable